import javax.jms.*;
import javax.naming.*;
import java.util.Hashtable;

class CreateTopic
{
	// ***** Step 1: Set LDAP Context Factory and Initial Context

	static final String  contextFactory = "com.sun.jndi.ldap.LdapCtxFactory";

	static final String  providerURL ="ldap://localhost:389/o=NetscapeRoot";

	public static void main(String[] args)
	{
		String 		topicName = null;
		Context 		context= null;

		if (args.length < 1)
		{
			System.out.println("Usage: java CreateTopic <Topic>");
			System.exit(1);
		}

		topicName = args[0];
		System.out.println("Topic is:"+ topicName);

		Hashtable env = new Hashtable();
		env.put(Context.INITIAL_CONTEXT_FACTORY, contextFactory);
		env.put(Context.PROVIDER_URL, providerURL);

	// ***** Step 2: Set LDAP Administrator user/password

		env.put(Context.SECURITY_PRINCIPAL, "cn=Directory Manager");

		env.put(Context.SECURITY_CREDENTIALS, "administrator");
		try {
			context = new InitialContext(env);
		}
		catch (Exception e)
		{
			System.out.println("Could not create JNDI API context: " + e);
			System.exit(1);
		}

		try {
         
	// ***** Step 3: Create a new Tibco JMS Topic object

			Topic t= new com.tibco.tibjms.TibjmsTopic(topicName) ;

	// ***** Step 4: Bind the new object into its LDAP location

                    context.bind("cn=" + topicName, t);
		}
		catch (Exception e)
		{
			System.out.println("Could not bind topic: " + e);
			System.exit(1);
		}
	}
}
