////////////////////////////////////////////////////
// TIBCO Enterprise for JMS - JAVA API
// TIBCO Education Services
// Copyright 2003 - TIBCO Software Inc.
// ALL RIGHTS RESERVED
////////////////////////////////////////////////////

import javax.jms.*;
import javax.naming.*;
import java.util.Hashtable;

public class Qlient
{
    static final String  providerContextFactory =
                            "com.tibco.tibjms.naming.TibjmsInitialContextFactory";
    static final String  providerURL ="tibjmsnaming://localhost:7222";

	public static void main(String[] args)
	{
		String 				QueueName = null;
		Context 				jndiContext = null;
		ConnectionFactory			cFactory = null;
		QueueConnection			tconn = null;
		QueueSession			tsession = null;
		Destination 			myDest=null;
		QueueRequestor			myRequestor = null;
		TextMessage				msg = null;

		if (args.length!=1)
		{
			System.out.println("Usage: java Client <Queue>");
			System.exit(1);
		}

		QueueName = new String(args[0]);
		System.out.println("Queue is:"+ QueueName);

		try
		{
			Hashtable env = new Hashtable();
			env.put(Context.INITIAL_CONTEXT_FACTORY,providerContextFactory);
			env.put(Context.PROVIDER_URL,providerURL);
	    		jndiContext = new InitialContext(env);

			// **** Step 1 create Queue connection factory
    			cFactory = (ConnectionFactory)jndiContext.lookup("QueueConnectionFactory");
		}
		catch (NamingException e)
		{
			System.out.println("Could not create JNDI API context: " + e.toString());
			System.exit(1);
		}

		try
		{
			// **** Step 2 Create Connection, Session
			tconn = (QueueConnection)cFactory.createConnection();
			tsession = tconn.createQueueSession(false,Session.AUTO_ACKNOWLEDGE);

			myDest = (Destination)jndiContext.lookup(QueueName);

			// **** Step 3 Create Requestor
			myRequestor = new QueueRequestor(tsession, (Queue)myDest);

			msg = tsession.createTextMessage("QUERY");

                 tconn.start();

			// **** Step 4 Send message
			Message reply= myRequestor.request(msg);

			if  (reply instanceof TextMessage) {
 				TextMessage m= (TextMessage)reply;
				System.out.println("REPLY: " + m.getText());
			}
			else
				System.out.println("REPLY: " + reply);
		}
		catch (NamingException e)
		{
			System.out.println("Could not create JNDI API context: " + e.toString());
			System.exit(1);
		}
		catch (JMSException e)
		{
			System.out.println("Exception in send message :" + e.toString());
			System.exit(1);
		}
		finally
		{
			if (tconn != null)
			try
			{
				tconn.close();
			}
			catch(JMSException e)
			{
				System.out.println("Exception:" + e.toString());
			}
		}
	}
}
