/* 
 * Copyright(c) 2001 TIBCO Software Inc. 
 * All rights reserved.
 * For more information, please contact:
 * TIBCO Software Inc., Palo Alto, California, USA
 * Written By : Medha Samant
 * History : 
 *  Written Date : Nov 2001 
 */
/*
 * InMemoryStructure.java
 * DESCRIPTION : InMemoryHashtable structure that will maintain the state of
 *               orders during asynchronous request reply
 *
 */

import javax.jms.*;

public class InMemoryStructure
{
    
        private String _xmlMessage;         //Message Text Received From Servlet
        private Destination _replyToDestination;        //Reply Destination To send Reply Back To servlet
        private String _statusCreditCheck;  //Status from Credit Check - SUCCESS or UNSUCCESS
        private String _creditDetails;      //Details from Credit Check 
        private String _statusInventoryCheck;//Status from Inventory Check - SUCCESS or UNSUCCESS
        private String _inventoryDetails;   //Details from Credit Check 
        private double _requiredCredit;     //Total Value From Servlet
        
        public InMemoryStructure(String sValue, Destination rValue)
        {
            _xmlMessage = sValue;
            _replyToDestination = rValue;
        }
        
        public void setRequiredCredit(double dValue)
        {
            _requiredCredit = dValue;
        }
        
        public void setCreditCheck(String sValue1, String sValue2)
        {
            _statusCreditCheck = sValue1;
            _creditDetails = sValue2;
        }
        
        public void setInventoryCheck(String sValue1, String sValue2)
        {
            _statusInventoryCheck = sValue1;
            _inventoryDetails = sValue2;
        }
        
        public String getXmlMessage() 
        {
            return _xmlMessage;
        }
        
        public String getCreditStatus() 
        {
            return _statusCreditCheck;
        }
        
        public String getInventoryStatus() 
        {
            return _statusInventoryCheck;
        }
        
        public String getCreditDetails() 
        {
            return _creditDetails;
        }
        
        public String getInventoryDetails() 
        {
            return _inventoryDetails;
        }
        
        public double getRequiredCredits() 
        {
            return _requiredCredit;
        }
        
        /*public String getReplyToDestinationName() {
            return _replyToDestinationName;
        }*/
        public Destination getReplyToDestination() 
        {
            return _replyToDestination;
        }       
}
        
        