create or replace PROCEDURE INVENTORY_DATA_UPDATE
(
	ITEM		 IN  VARCHAR2,
	QUANTITY	 IN  VARCHAR2,
	STATUS		 OUT VARCHAR2,
	DETAILS		 OUT VARCHAR2
)
AS

	   TYPE ITEM_LIST IS TABLE OF VARCHAR2(50) INDEX BY BINARY_INTEGER;
	   TYPE QUANTITY_LIST IS TABLE OF NUMBER INDEX BY BINARY_INTEGER;
	   P_ITEM_LIST		ITEM_LIST;
	   P_QUANTITY_LIST	QUANTITY_LIST;
	   P_CNT		    NUMBER;
	   P_CUR_PNT		NUMBER;
	   P_CUR_OCCURANCE	NUMBER;
	   P_TMP		    NUMBER;
	   P_LENGTH  		NUMBER;
	   P_TOTAL 		    NUMBER;
	   P_TMP_QTY 		NUMBER;
	   P_QUANTITY_TMP	VARCHAR2(50);

BEGIN
DBMS_OUTPUT.ENABLE(10000);

    /* GET THE LIST OF ITEMS*/
	P_CNT  		:=0;
	P_CUR_PNT   :=1;
	LOOP
		P_TMP := INSTR(ITEM, '|', P_CUR_PNT ,1);
		IF (P_TMP = 0)
		THEN

			P_ITEM_LIST(P_CNT)  := SUBSTR(ITEM, P_CUR_PNT) ;
			DBMS_OUTPUT.PUT_LINE(P_ITEM_LIST(P_CNT));
			EXIT;
		ELSE
			P_LENGTH := P_TMP - P_CUR_PNT + 1;
			P_ITEM_LIST(P_CNT) := SUBSTR(ITEM, P_CUR_PNT, (P_LENGTH-1));
			DBMS_OUTPUT.PUT_LINE(P_ITEM_LIST(P_CNT));
		END IF;
		P_CNT := P_CNT + 1;
		P_CUR_PNT := P_TMP + 1;
		/*DBMS_OUTPUT.PUT_LINE(P_CUR_PNT);*/
	END LOOP;

	/* GET THE LIST OF QUANTITY*/
	P_CNT  :=0;
	P_CUR_PNT :=1;
	LOOP
		P_TMP := INSTR(QUANTITY, '|', P_CUR_PNT ,1);
		IF (P_TMP = 0)
		THEN

			P_QUANTITY_LIST(P_CNT) := SUBSTR(QUANTITY, P_CUR_PNT);
			DBMS_OUTPUT.PUT_LINE(P_QUANTITY_LIST(P_CNT));
			EXIT;
		ELSE
			P_LENGTH := P_TMP - P_CUR_PNT + 1;
			P_QUANTITY_TMP := SUBSTR(QUANTITY, P_CUR_PNT, (P_LENGTH-1));
			P_QUANTITY_LIST(P_CNT) := TO_NUMBER(P_QUANTITY_TMP);
			DBMS_OUTPUT.PUT_LINE(P_QUANTITY_LIST(P_CNT));
		END IF;
		P_CNT := P_CNT + 1;
		P_CUR_PNT := P_TMP + 1;
		/*DBMS_OUTPUT.PUT_LINE(P_CUR_PNT);*/
	END LOOP;
	P_TOTAL := P_CNT;
	STATUS := 'SUCCESS';
	DETAILS := '';

	P_CNT := 0;
	LOOP

		SELECT ITEM_QUANTITY INTO P_TMP_QTY FROM INVENTORY_DATA WHERE ITEM_NAME = P_ITEM_LIST(P_CNT);
		P_TMP_QTY := P_TMP_QTY - P_QUANTITY_LIST(P_CNT);
		UPDATE INVENTORY_DATA SET ITEM_QUANTITY = P_TMP_QTY WHERE ITEM_NAME = P_ITEM_LIST(P_CNT);
		DBMS_OUTPUT.PUT_LINE(P_QUANTITY_LIST(P_CNT));
		IF (P_CNT = P_TOTAL)
		THEN
			EXIT;
		END IF;
		P_CNT := P_CNT + 1;
	END LOOP;

END INVENTORY_DATA_UPDATE;
/
