/* 
 * Copyright(c) 2001 TIBCO Software Inc. 
 * All rights reserved.
 * For more information, please contact:
 * TIBCO Software Inc., Palo Alto, California, USA
 * Written By : Kiet Duong
 * History : 
 *  Written Date : Nov 2001 
 */

/*
 * DoGetPostServlet.java
 * DESCRIPTION :An abstract class to provide callback function for both get and post HTTP operation.
 *
 */
 
package com.tibco.tibchoc;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

abstract public class DoGetPostServlet extends HttpServlet
{
	public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException
	{
	    doGetPost(req, res);
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException
	{
		doGet(req,res);
	}

	protected void doGetPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException
	{
		res.setContentType("text/html");
		PrintWriter out = res.getWriter();

		String htmlData = "Some data to be displaced!";
		String title = "Welcome to doGet and doPost servlet...";
		
		wrapInHtmlPage(out,htmlData,title);
	}
	
	protected abstract void wrapInHtmlPage(PrintWriter out, String queryResult, String title)throws IOException;
}
