/* 
 * Copyright(c) 2001 TIBCO Software Inc. 
 * All rights reserved.
 * For more information, please contact:
 * TIBCO Software Inc., Palo Alto, California, USA
 * Written By : Medha Samant
 * History : 
 *  Written Date : Nov 2001 
 */

/*
 * DomDoc.java
 * DESCRIPTION :  Wraps DOM code to make life a little easier
 *
 */

package com.tibco.tibchoc;


import java.io.StringReader;



import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;

import org.xml.sax.InputSource;
import org.w3c.dom.Document;
import org.w3c.dom.Text;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;


public class DomDoc
{

    private static DocumentBuilder _domDocBuilder = null;

    protected Document _domDoc;
    protected String   _xml;
    protected boolean  _valid;

    public DomDoc()
    {
    }

    public DomDoc(String xml)
    {
        _xml = xml;
        _valid = false;
    }

    public boolean parse()
    {

        DocumentBuilder builder = getDocBuilder();
        if (builder != null)
        {
            try
            {
                synchronized(builder) {
                   _domDoc = builder.parse(new InputSource(new StringReader(_xml)));
                }
                _valid = true;
            }
            catch (Exception x)
            {
                System.out.println("error creating DOM Document object " +  x);
                _valid = false;
            }
        }

        /*
        NodeList nodeList = _domDocIn.getElementsByTagName("*");

        for (int i = 0 ; i < nodeList.getLength() ; i++)
        {
            Node node = nodeList.item(i);
            String name = node.getNodeName();
            if (node.getNodeType() == Node.ELEMENT_NODE)
            {
                Node child = node.getFirstChild();
                if (child.getNodeType() == Node.TEXT_NODE)
                {
                    Text txt = (Text)child;
                    trc.dbg("node: "+name+"  value: "+txt.getData());
                }
            }
        }
        */

        return _valid;
    }

    public boolean isValid()
    {
        return _valid;
    }

    public String getString()
    {
        return _xml;
    }

    public String get(String name)
    {
        String data = "";

        NodeList nodeList = _domDoc.getElementsByTagName(name);
        for (int i = 0 ; i < nodeList.getLength() ; i++)
        {
            Node node = nodeList.item(i);
            if (node.getNodeType() == Node.ELEMENT_NODE)
            {
                Node child = node.getFirstChild();
                if (child.getNodeType() == Node.TEXT_NODE)
                {
                    data += ((Text)child).getData();
                }
            }
       }
        return data;
    }

    public static DocumentBuilder getDocBuilder()
    {
        if (_domDocBuilder == null)
        {
            try
            {
                DocumentBuilderFactory docBldFac = DocumentBuilderFactory.newInstance();
                _domDocBuilder = docBldFac.newDocumentBuilder();
            }
            catch (Exception x)
            {
                System.out.println("error accessing DOM DocumentBuilder object " +  x);
                _domDocBuilder = null;
            }
        }
        return _domDocBuilder;
    }
        
    public Node getNode(String name)
    {
        NodeList nodeList = _domDoc.getElementsByTagName(name);
        return nodeList.item(0);
    }
    public int getLength(String name)
    {
        NodeList nodeList = _domDoc.getElementsByTagName(name);
        return nodeList.getLength();
    }

    public String getNthElement(String name, int n)
    {
        String data = "";

        NodeList nodeList = _domDoc.getElementsByTagName(name);
        Node node = nodeList.item(n);
        if (node.getNodeType() == Node.ELEMENT_NODE)
        {
            Node child = node.getFirstChild();
            if (child.getNodeType() == Node.TEXT_NODE)
            {
                 data = ((Text)child).getData();
             }
        }
       
        return data;
    }
    
}

